<?php

class ControllerPaymentpas extends Controller {
	protected function index() {
		$this->language->load('payment/pas');
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$this->load->library('encryption');
		$encryption = new Encryption($this->config->get('config_encryption'));
	
		$this->data['order_id'] = $this->session->data['order_id'];
		$this->data['back'] = $this->url->link('checkout/payment', '', 'SSL');

		$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$amount = round($amount);
		$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
		
        $this->data['order_id'] = $this->session->data['order_id'];
		$this->data['action'] = "https://sepehrpay.shaparak.ir:8080";
		
		$amount = trim($amount);
		$invoiceNumber = time();

		$redirectAddress = ($this->url->link('payment/pas/callback','', 'SSL'));;
		$terminal = trim($this->config->get('pas_Terminal'));
		$this->data['error_warning'] = '';
		
		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://sepehrpay.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				$this->data['TerminalID']=$terminal;
				$this->data['token']=$res['Accesstoken'];
				if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/pas.tpl')) 
				{
					$this->template = $this->config->get('config_template') . '/template/payment/pas.tpl';
				} else 
				{
					$this->template = 'default/template/payment/pas.tpl';
				}
				$this->render();
		
			}else
			{
				$this->data['error_warning']=('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
				if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/pas.tpl')) 
				{
					$this->template = $this->config->get('config_template') . '/template/payment/pas.tpl';
				} else 
				{
					$this->template = 'default/template/payment/pas.tpl';
				}
				$this->render();
			}
		}
		else
		{
			$this->data['error_warning']=('پورت 8081 در هاست شما بسته است !');
			$this->template = 'default/template/payment/pas.tpl';
			$this->render();
		}
	
		
	}

	public function callback() 
	{
		$this->language->load('payment/pas');

		$order_id =  $this->session->data['order_id'];
		

		$this->document->setTitle($this->language->get('text_heading'));
		$this->data['text_wait'] = $this->language->get('text_wait');
		$this->data['text_heading'] = $this->language->get('text_heading');
		$this->data['text_results'] = $this->language->get('text_results');
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_continue'] = $this->language->get('button_continue');
		$this->data['breadcrumbs'] = array();
		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/home', '', 'SSL'), 'separator' => false);
		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_heading'), 'href' => $this->url->link('payment/pas/callback', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		$this->data['error_warning'] = '';
		
		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($order_id);


			$terminal = trim($this->config->get('pas_Terminal'));
			$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$amount = round($amount);
			$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
			
			if ($order_info) 
			{
				
				$_POST['digitalreceipt'] = $this->db->escape($this->request->post["digitalreceipt"]);
				$order_history = $this->db->query("SELECT count(*) as cc FROM " . DB_PREFIX . "order_history WHERE comment = '" .$_POST['digitalreceipt']. "'");
				if ($order_history->num_rows && $order_history->row['cc'] == 0) 
				{
					$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, 'https://sepehrpay.shaparak.ir:8081/V1/PeymentApi/Advice');
					curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);
					$result = json_decode($res,true);
					if (strtoupper($result['Status']) == 'OK') 
					{
						if(floatval($result['ReturnId'])  == floatval($amount))
						{
							$referenceId = $_POST['digitalreceipt'];
							$this->data['authority'] = $referenceId;

							$this->model_checkout_order->confirm($order_id, $this->config->get('pas_order_status_id'),$this->data['authority'], true);
							$location = ($this->url->link('checkout/success', '', 'SSL'));
							if (!headers_sent()) {
								header('Location: ' . $location);
							  } else
							  {
								  echo '<script type="text/javascript">';
								  echo 'window.location.href="' . $location . '";';
								  echo '</script>';
							  }
			
						}
						else
						{
							$this->data['error_warning'] = 'مبلغ واریزی با مبلغ سفارش برابر نیست';
							$this->data['continue'] = $this->url->link('checkout/checkout');
						}
					 }
					 else
					{
						switch($result['ReturnId'])
						{
							case '-1' : $res = 'تراکنش پیدا نشد';break;
							case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
							case '-3' : $res = 'خطا عمومی';break;
							case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
							case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
							default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
							
						}
						$this->data['error_warning'] = $res;
						$this->data['continue'] = $this->url->link('checkout/checkout');
					}
				}
				else
				{
					$this->data['error_warning'] = 'رسید قبلا استفاده شده است';
					$this->data['continue'] = $this->url->link('checkout/checkout');
				}
				
			}
			else 
			{
				$this->data['error_warning'] =$this->language->get('error_order_id');
				$this->data['continue'] = $this->url->link('checkout/checkout');
			}
		} 
		else 
		{
			$this->data['error_warning'] = $_POST['respmsg'];
			$this->data['continue'] = $this->url->link('checkout/checkout');
		}
		
		/* Template */
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/pas_confirm.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/pas_confirm.tpl';
		} else {
			$this->template = 'default/template/payment/pas_confirm.tpl';
		}
	
		$this->children = array(
			'common/column_left',
			'common/column_right',
			'common/content_top',
			'common/content_bottom',
			'common/footer',
			'common/header'
		);
		
		$this->response->setOutput($this->render());
	}

}
?>